package returnCmd {
	
	function serverCmdDropPlayerAtCamera(%client) {
		%obj = %client.player;
		
		if (isObject(%obj))
			%client.returnPos = %obj.getTransform();
		
		return parent::serverCmdDropPlayerAtCamera(%client);
	}
	
	function serverCmdFetch(%client, %victim) {
		%target = findClientByName(%victim);
		%obj = %target.player;
		
		if (isObject(%obj))
			%target.returnPos = %obj.getTransform();
		
		return parent::serverCmdFetch(%client, %victim);
	}
	
	function serverCmdFind(%client, %victim) {
		%obj = %client.player;
		
		if (isObject(%obj))
			%client.returnPos = %obj.getTransform();
		
		return parent::serverCmdFind(%client, %victim);
	}
	
	function gameConnection::onDeath(%client, %src, %perp, %type, %pos) {
		%obj = %client.player;
		
		if (isObject(%obj))
			%client.returnPos = %obj.getTransform();
		
		return parent::onDeath(%client, %src, %perp, %type, %pos);
	}
	
};

activatePackage(returnCmd);

function serverCmdReturn(%client, %victim) {
	if (!%client.isAdmin)
		return;
	
	if (%victim $= "") {
		%victim = %client;
	} else {
		%victim = findClientByName(%victim);
		if (!%victim)
			return;
	}
	
	%obj = %victim.player;
	
	if (%victim.returnPos $= "" || !isObject(%obj))
		return;
	
	%previous = %victim.returnPos;
	
	if (%obj.isMounted()) {
		%mountObj = %obj.getObjectMount();
		%victim.returnPos = %mountObj.getTransform();
		
		%mountObj.teleportEffect();
		%mountObj.setTransform(%previous);
		
		return;
	} else {
		%obj.teleportEffect();
		%victim.returnPos = %obj.getTransform();
	}
	
	%obj.setTransform(%previous);
}